import java.io.*;
import java.util.*;

public class RunOPT {
  //Construct the application
  //String database = "Haplotype100_10_20.dat";
  //String database = "combine_data-hap-20.dat";
  String database;
  String tingdatabase = "data-hap-160.dat";
  int NumberOfMissingData = 0;
  
  public RunOPT(int n, String name) {
  	NumberOfMissingData = n;
  	database = name;
  	
  	try {
    	Optmize opt = new Optmize(this.NumberOfMissingData);

		//}databaseŪXTable
        BufferedReader br = new BufferedReader(new FileReader(new File(database)));
        Vector vt = new Vector();
        String input = br.readLine();
        while(input != null){
          //Begin of a new block
          StringTokenizer st = new StringTokenizer(input);
          String BlockID = st.nextToken();
          st.nextToken(); // Block count
          StringBuffer sb = new StringBuffer(st.nextToken());
          vt.add(sb);

          //Read next line to see if the block ID is the same
          input = br.readLine();
          while(input != null){
            StringTokenizer st2 = new StringTokenizer(input);
            String NextBlockID = st2.nextToken();
            if(!NextBlockID.equals(BlockID))
              //Block IDs are different
              break;
            else{
              //Block IDs are the same, store this block into vector
              st2.nextToken(); // Block count
              StringBuffer sb1 = new StringBuffer(st2.nextToken());
              //vt.add(sb);

              boolean same = true;
              //Discard identical haplotype patterns
              for (int i = 0; i < vt.size(); i++) {
                StringBuffer sb2 = (StringBuffer) vt.elementAt(i);

                same = true;
                for (int j = 0; j < sb2.length(); j++) {
                  if (sb1.charAt(j) != sb2.charAt(j) && sb1.charAt(j) != 'n' &&
                      sb2.charAt(j) != 'n') {
                    same = false;
                    break;
                  }
                }

                if (same == true) {
                  break;
                }
              }
              if(same == false)
                vt.add(sb1);
                
              //Read next line to see if the block ID is the same
              input = br.readLine();
            }// end of else
          }//end of inner while loop

          Greedy2 g2 = new Greedy2(this.NumberOfMissingData);
          g2.Reduce(vt, BlockID);
          //if greedy make sures there is a solution
          if(g2.run()){
            //Reformulate the bialleles to the bipartite graph
            opt.Reduce(vt, BlockID);
            //find the optimum solution
            opt.run();
          }
          //reset the vector
          vt.clear();
        }//end of outer while loop

        opt.close();
        br.close();
    }//end of try
    catch(Exception e2){
      e2.printStackTrace();
    }
  }

  //Main method
  public static void main(String[] args) {
    new RunOPT(Integer.parseInt(args[0]), args[1]);
  }
}